The BulletChart component for Angular represents a widget which features two measures - a primary one (the pointer) and a comparative one (the target) and displays them in the context of a number of differently styled qualitative ranges.
Introduction:
The jqxBulletChart is a versatile chart widget used to visualize a single measure against predefined performance ranges, such as target values, benchmarks, or thresholds. It’s often used for displaying progress against a goal or for showing key performance indicators (KPIs).
To use jqxBulletChart in an Angular 19 application with standalone components, follow these steps:
npm install jqwidgets-ng --save
app.component.ts
:
import { Component } from '@angular/core';
import { jqxBulletChartModule } from 'jqwidgets-ng/jqxbulletchart';
import { CommonModule } from '@angular/common';
@Component({
selector: 'app-root',
standalone: true,
imports: [CommonModule, jqxBulletChartModule],
template: `
<h2>Bullet Chart Example</h2>
<jqxBulletChart
[ranges]="ranges"
[target]="target"
[pointer]="pointer"
[ticks]="ticks">
</jqxBulletChart>
`,
styleUrls: ['./app.component.css']
})
export class AppComponent {
title: string = 'Revenue 2025 YTD';
description: string = '(U.S. $ in thousands)';
ranges: any[] = [
{ startValue: 0, endValue: 200, color: '#000000', opacity: 0.5 },
{ startValue: 200, endValue: 250, color: '#000000', opacity: 0.3 },
{ startValue: 250, endValue: 300, color: '#000000', opacity: 0.1 }
];
pointer: any = { value: 270, label: 'Revenue 2025 YTD', size: '25%', color: 'Black'};
target: any = { value: 260, label: 'Revenue 2024 YTD', size: 4, color: 'Black' };
ticks: any = { position: 'both', interval: 50, size: 10 };
}
value: The current value to be displayed on the chart.
value: 75
ranges: Defines the ranges (e.g., performance thresholds) that the value is compared against.
ranges: [
{ startValue: 0, endValue: 200, color: '#000000', opacity: 0.5 },
{ startValue: 200, endValue: 250, color: '#000000', opacity: 0.3 },
{ startValue: 250, endValue: 300, color: '#000000', opacity: 0.1 }
]
target: The target value to be compared against (often shown as a line or marker in the chart).
target: 85
pointer: The pointer settings, including its color and size.
pointer: { color: "#0000FF", size: 5 }
title: Text to label the chart with (e.g., to show the target value).
title: "Target: 85"
getValue(): Retrieves the current value displayed on the chart.
let value = this.myBulletChart.getValue();
setValue(value): Sets a new value for the bullet chart.
this.myBulletChart.setValue(80);
refresh(): Refreshes the chart, especially useful when the chart is bound to dynamic data.
this.myBulletChart.refresh();
OnValueChanged: Triggered when the value changes in the chart.
this.myBulletChart.on('valueChanged', (event) => {
let value = event.args.value;
console.log("New Value: " + value);
});
OnPointerClick: Triggered when the pointer is clicked.
this.myBulletChart.on('pointerClick', (event) => {
console.log("Pointer clicked!");
});

Vue UI Components Documentation
Vue BulletChart Component
The BulletChart component for Vue represents data as a set of bars that reside on separate circular tracks.
Prerequisites
Refer to Vue Getting Started before you start with this help topic.
Configuration
After you have created your App.vue file, here is how you should structure it:
The BulletChart component for Vue requires the following import:
import JqxBulletChart from 'jqwidgets-scripts/jqwidgets-vue/vue_jqxbulletchart.vue';
Add the jqxBulletChart component to the components section of the the Vue class:
components: { JqxBulletChart },
Template
The App.vue has a <template>
structural tag where we determine the application structure.
There we will also set the tags for the new components - <JqxBulletCahrt/>
<template> <JqxBulletChart :width="350" :height="80" :barSize="'40%'" :labelsFormat="'c'" :showToolTip="true" :title="title" :description="description" :ranges="ranges" :pointer="pointer" :target="target" :ticks="ticks"> </JqxBulletChart></template>
Properties
The properties of the <JqxBulletChart/> component are defined in the data
member of the Vue class.
We should put them in the return object of the data function:
data: function () { return { width: 350, title: 'Revenue 2014 YTD', description: '(U.S. $ in thousands)', ranges: [ { startValue: 0, endValue: 200, color: '#000000', opacity: 0.5 }, { startValue: 200, endValue: 250, color: '#000000', opacity: 0.3 }, { startValue: 250, endValue: 300, color: '#000000', opacity: 0.1 } ], pointer: { value: 270, label: 'Revenue 2014 YTD', size: '25%', color: 'Black' }, target: { value: 260, label: 'Revenue 2013 YTD', size: 4, color: 'Black' }, ticks: { position: 'both', interval: 50, size: 10 } }}
Events
The events in Vue are set as an attribute with @ prefix, for example:
<JqxBulletChart :width="350" :height="80" :barSize="'40%'" :labelsFormat="'c'" :showToolTip="true" :title="title" :description="description" :ranges="ranges" :pointer="pointer" :target="target" :ticks="ticks" @change="onChange()"></JqxBulletChart>
All events that are bound to a component are implemented in the methods
member of the Vue class.
Methods
To use a component's method we should have its reference. In Vue we refer to a component by the special $refs
property.
Before that we need to add the desired name reference to that component:
<JqxBulletChart ref="bulletchart"></JqxBulletChart>
Here how you can use a component's method:
this.$refs.bulletchart.val(50);
If we want to add additional methods we should also implement them in the methods
member.
In case we need to do some precalculation or something else before the components are rendered, we should use the beforeCreate
member.
It depends on the case.
If you have followed the above steps, you App.vue file would look like this:

React UI Components Documentation

Typescript React BulletChart Component

This tutorial will show you the basics of how to get started with the jQWidgets BulletChart React Component.

Prerequisites

Refer to Getting Started with React before you start with this help topic.

Structure


I. Imports:

import * as React from 'react';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.base.css';
import 'jqwidgets-scripts/jqwidgets/styles/jqx.material-purple.css';
import JqxBulletChart, { IBulletChartProps } from 'jqwidgets-scripts/jqwidgets-react-tsx/jqxbulletchart';

II. Class:

class App extends React.PureComponent<{}, IBulletChartProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxBulletChart
width={this.state.width} height={"100%"} .....
/>
)
}
}

III. Render:

ReactDOM.render(<App />, document.getElementById('app'));

Events

The event names in React are constructed of the original event names starting with capital letter plus on upfront:

class App extends React.PureComponent<{}, IBulletChartProps> {
constructor(props: {}) {
super(props);
this.state = {
width: '100%'
// Other Widget Props
}
}
render() {
return (
<JqxBulletChart onNameOfEvent={this.handleEvent}
width={this.state.width} height={"100%"} .....
/>
)
}
private handleEvent(e: Event): void {
// Do Something ...
}
}

Methods & Properties

This is how you call methods & props:

Every component have a method setOptions which accepts a object as an argument. This object contains component settings.

this.myBulletChart.current!.setOptions({ width: 350, height: 400 });

Every component also have a method getOptions which returns the value of the requested option.

BulletChart API

API Reference of the jQWidgets BulletChart React Component: BulletChart API

BulletChart Demos

Demos Reference of the jQwidgets BulletChart React Component: BulletChart Demos